/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.4.1(a403b5269c7ab5b0f241aabbeb478fcda6821162)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
(function(){var e=["vs/platform/instantiation/common/instantiation","vs/languages/markdown/common/markdown","exports","vs/editor/common/modes/monarch/monarchCompile","vs/editor/common/modes","vs/languages/html/common/html","vs/editor/common/services/modeService","require","vs/platform/thread/common/thread","vs/platform/configuration/common/configuration","vs/editor/common/services/editorWorkerService","vs/editor/common/modes/abstractMode","vs/editor/common/modes/monarch/monarchLexer","vs/editor/common/modes/languageConfigurationRegistry","vs/base/common/async"],t=function(t){for(var o=[],n=0,s=t.length;s>n;n++)o[n]=e[t[n]];return o},o=this&&this.__extends||function(e,t){function o(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)},n=this&&this.__decorate||function(e,t,o,n){var s,r=arguments.length,i=3>r?t:null===n?n=Object.getOwnPropertyDescriptor(t,o):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)i=Reflect.decorate(e,t,o,n);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(i=(3>r?s(i):r>3?s(t,o,i):s(t,o))||i);return r>3&&i&&Object.defineProperty(t,o,i),i},s=this&&this.__param||function(e,t){return function(o,n){t(o,n,e)}};define(e[1],t([7,2,3,4,5,6,0,8,9,10,11,12,13,14]),function(e,t,r,i,a,c,m,T,p,d,l,g,h,E){"use strict";t.TOKEN_HEADER_LEAD="entity.name.tag",t.TOKEN_HEADER="entity.name.tag",t.TOKEN_EXT_HEADER="entity.other.attribute-name",t.TOKEN_SEPARATOR="meta.separator",t.TOKEN_QUOTE="comment",t.TOKEN_LIST="keyword",t.TOKEN_BLOCK="string",t.TOKEN_BLOCK_CODE="variable.source",t.language={defaultToken:"",tokenPostfix:".md",control:/[\\`*_\[\]{}()#+\-\.!]/,noncontrol:/[^\\`*_\[\]{}()#+\-\.!]/,escapes:/\\(?:@control)/,jsescapes:/\\(?:[btnfr\\"']|[0-7][0-7]?|[0-3][0-7]{2})/,empty:["area","base","basefont","br","col","frame","hr","img","input","isindex","link","meta","param"],tokenizer:{root:[[/^(\s{0,3})(#+)((?:[^\\#]|@escapes)+)((?:#+)?)/,["white",t.TOKEN_HEADER_LEAD,t.TOKEN_HEADER,t.TOKEN_HEADER]],[/^\s*(=+|\-+)\s*$/,t.TOKEN_EXT_HEADER],[/^\s*((\*[ ]?)+)\s*$/,t.TOKEN_SEPARATOR],[/^\s*>+/,t.TOKEN_QUOTE],[/^\s*([\*\-+:]|\d+\.)\s/,t.TOKEN_LIST],[/^(\t|[ ]{4})[^ ].*$/,t.TOKEN_BLOCK],[/^\s*~{3}\s*((?:\w|[\/\-#])+)?\s*$/,{token:t.TOKEN_BLOCK,next:"@codeblock"}],[/^\s*```\s*((?:\w|[\/\-#])+)\s*$/,{token:t.TOKEN_BLOCK,next:"@codeblockgh",nextEmbedded:"$1"}],[/^\s*`{3}\s*$/,{token:t.TOKEN_BLOCK,next:"@codeblock"}],{include:"@linecontent"}],codeblock:[[/^\s*~{3}\s*$/,{token:t.TOKEN_BLOCK,next:"@pop"}],[/^\s*`{3}\s*$/,{token:t.TOKEN_BLOCK,next:"@pop"}],[/.*$/,t.TOKEN_BLOCK_CODE]],codeblockgh:[[/```\s*$/,{token:"@rematch",switchTo:"@codeblockghend",nextEmbedded:"@pop"}],[/[^`]*$/,t.TOKEN_BLOCK_CODE]],codeblockghend:[[/\s*```/,{token:t.TOKEN_BLOCK_CODE,next:"@pop"}],[/./,"@rematch","@pop"]],linecontent:[[/&\w+;/,"string.escape"],[/@escapes/,"escape"],[/\b__([^\\_]|@escapes|_(?!_))+__\b/,"strong"],[/\*\*([^\\*]|@escapes|\*(?!\*))+\*\*/,"strong"],[/\b_[^_]+_\b/,"emphasis"],[/\*([^\\*]|@escapes)+\*/,"emphasis"],[/`([^\\`]|@escapes)+`/,"variable"],[/\{[^}]+\}/,"string.target"],[/(!?\[)((?:[^\]\\]|@escapes)*)(\]\([^\)]+\))/,["string.link","","string.link"]],[/(!?\[)((?:[^\]\\]|@escapes)*)(\])/,"string.link"],{include:"html"}],html:[[/<(\w+)\/>/,a.htmlTokenTypes.getTag("$1")],[/<(\w+)/,{cases:{"@empty":{token:a.htmlTokenTypes.getTag("$1"),next:"@tag.$1"},"@default":{token:a.htmlTokenTypes.getTag("$1"),bracket:"@open",next:"@tag.$1"}}}],[/<\/(\w+)\s*>/,{token:a.htmlTokenTypes.getTag("$1"),bracket:"@close"}],[/<!--/,"comment","@comment"]],comment:[[/[^<\-]+/,"comment.content"],[/-->/,"comment","@pop"],[/<!--/,"comment.content.invalid"],[/[<\-]/,"comment.content"]],tag:[[/[ \t\r\n]+/,"white"],[/(type)(\s*=\s*)(")([^"]+)(")/,[a.htmlTokenTypes.ATTRIB_NAME,a.htmlTokenTypes.DELIM_ASSIGN,a.htmlTokenTypes.ATTRIB_VALUE,{token:a.htmlTokenTypes.ATTRIB_VALUE,switchTo:"@tag.$S2.$4"},a.htmlTokenTypes.ATTRIB_VALUE]],[/(type)(\s*=\s*)(')([^']+)(')/,[a.htmlTokenTypes.ATTRIB_NAME,a.htmlTokenTypes.DELIM_ASSIGN,a.htmlTokenTypes.ATTRIB_VALUE,{token:a.htmlTokenTypes.ATTRIB_VALUE,switchTo:"@tag.$S2.$4"},a.htmlTokenTypes.ATTRIB_VALUE]],[/(\w+)(\s*=\s*)("[^"]*"|'[^']*')/,[a.htmlTokenTypes.ATTRIB_NAME,a.htmlTokenTypes.DELIM_ASSIGN,a.htmlTokenTypes.ATTRIB_VALUE]],[/\w+/,a.htmlTokenTypes.ATTRIB_NAME],[/\/>/,a.htmlTokenTypes.getTag("$S2"),"@pop"],[/>/,{cases:{"$S2==style":{token:a.htmlTokenTypes.getTag("$S2"),switchTo:"@embedded.$S2",nextEmbedded:"text/css"},"$S2==script":{cases:{$S3:{token:a.htmlTokenTypes.getTag("$S2"),switchTo:"@embedded.$S2",nextEmbedded:"$S3"},"@default":{token:a.htmlTokenTypes.getTag("$S2"),switchTo:"@embedded.$S2",nextEmbedded:"text/javascript"}}},"@default":{token:a.htmlTokenTypes.getTag("$S2"),next:"@pop"}}}]],embedded:[[/[^"'<]+/,""],[/<\/(\w+)\s*>/,{cases:{"$1==$S2":{token:"@rematch",next:"@pop",nextEmbedded:"@pop"},"@default":""}}],[/"([^"\\]|\\.)*$/,"string.invalid"],[/'([^'\\]|\\.)*$/,"string.invalid"],[/"/,"string",'@string."'],[/'/,"string","@string.'"],[/</,""]],string:[[/[^\\"']+/,"string"],[/@jsescapes/,"string.escape"],[/\\./,"string.escape.invalid"],[/["']/,{cases:{"$#==$S2":{token:"string",next:"@pop"},"@default":"string"}}]]}};var k=function(e){function a(o,n,s,c,m,T){e.call(this,o.id);var p=r.compile(o.id,t.language);this.tokenizationSupport=g.createTokenizationSupport(c,this,p),h.LanguageConfigurationRegistry.register(this.getId(),a.LANG_CONFIG),i.SuggestRegistry.register(this.getId(),{triggerCharacters:[],shouldAutotriggerSuggest:!1,provideCompletionItems:function(e,t,o){return E.wireCancellationToken(o,m.textualSuggest(e.uri,t))}},!0)}return o(a,e),a.LANG_CONFIG={comments:{blockComment:["<!--","-->"]},brackets:[["{","}"],["[","]"],["(",")"],["<",">"]],autoClosingPairs:[]},a=n([s(1,m.IInstantiationService),s(2,T.IThreadService),s(3,c.IModeService),s(4,d.IEditorWorkerService),s(5,p.IConfigurationService)],a)}(l.AbstractMode);t.MarkdownMode=k})}).call(this);
//# sourceMappingURL=../../../../../min-maps/vs/languages/markdown/common/markdown.js.map